% K.A. Strain 12/99. v 1.00. 
% Tested on Matlab 5.3 should be OK on 5.2. Will NOT run on the EDU 5.0 version (Europe)!
% Plots are mostly generated by using the LTI viewer. 
% Therefore many plot routines are
% removed from this program. 

% set up the pendulum LTI system
%for most purposes it is necessary to switch on the local controls,
%but they can be turned off by setting lc_onq = logical(0)

%2 modes of operation 1 for global/local  control one for mode
%frequencies
clear all
close all
global pend
pend.title = 'Pendulum parameters and derived properties';

%//this next section can be edited freely:-
mode = logical(1);  % 0 -want modes of undamped pendulum; 1 -want LC 
lc_onq = logical(1);
globalmode = logical(0);
%//until here
if mode ==logical(0)
   lc_onq = logical(0);
end
if globalmode == logical(1)
   lc_onq = logical(1);   %on occasion this may be wrong!
   mode   = logical(1);
end
%call the function to make the 4 state-space systems
%based on the pendulum model quadp
for index = 0:6
   gainf = 2.3^index;
   p = ssmake4p(mode,lc_onq,gainf);
   %recover the 4 possible systems
   lp = minreal(p.lp);  %two derivations agree
   f = logspace(-1,1,9999);
   w = 2*pi*f;
   [mag,phase] = bode(lp.a,lp.b,lp.c,lp.d,1,w);
   mag_tm = mag(:,5);
   %this one is based on the stiff system gs-13 noise below 1hz and 
   %the total noise from 1 to 10 Hz - representing corner station  motions
   %with respect to a local reference
   spm = ones(1,length(f));
   spm1 = spm./f.^4.*1e-12;
   spm2 = spm./f*1e-12;
   spm  = sqrt(spm1.^2 + spm2.^2);
   %
   mag_tm = mag_tm.*spm';
   %   
   %this routine (below) is routinely used to calculate the rms of a spectrum
   %it is up to the used to ensure that the limits of the frequency vector
   % f are wide enough, and the resolution high enough
   mrms  = 0.*f;
   mrms(length(f))=mag_tm(length(f));
   for k = (length(f)-1):-1:1;
      mrms(k)=sqrt(mrms(k+1)^2+(f(k+1)-f(k))*mag_tm(k)^2);
   end
   % mrms now contains an incremental high to low frequency rms 
   loglog(f,mag_tm,'b--',f,mrms,'r-')
  axis([min(f),max(f),1e-20,1e-8])
   title('Locked longitudinal mirror motion with "ground" input spectrum')
   legend('m/Hz^{1/2}','m rms')
   grid on
   hold on
   xlabel('frequency (Hz)')
   ylabel('displacement')
   
end