%adapted from Calum Torrie's ssmake4p by Ken Strain 3/01
%yaw and roll bugs fixed?  
global pend
quadopt;
% general redefintion of variables to simplify notation
% and cope with different pendulum designs
g = pend.g;
kcn	=  1/2 * (2*pi*pend.ufcn)^2*pend.mn;
kc1	=  1/2 * (2*pi*pend.ufc1)^2*pend.m1;
kc2	=  1/2 * (2*pi*pend.ufc2)^2*pend.m2;
ln   = pend.ln;
l1   = pend.l1;
l2   = pend.l2;
l3   = pend.l3;
kwn	=pend.Y1*pi*pend.rn^2/ln*pend.nwn/2;
kw1	=pend.Y1*pi*pend.r1^2/l1*pend.nw1/2;	
kw2	=pend.Y2*pi*pend.r2^2/l2*pend.nw2/2;	
kw3	=pend.Y3*pi*pend.r3^2/l3*pend.nw3/2;	

kn= kcn*kwn/(kcn+kwn);

k1v= kc1*kw1/(kc1+kw1);	 	%for vertical
k1p= 2*kw1; 			%for pitch

k2v= kc2*kw2/(kc2+kw2);	 	%for vertical
k2p= 2*kw2; 			%for pitch

k3= kw3;



%********************************************************************
% allows choice of 2 wires to set separation to zero
sn = 0;
s0=pend.su;
s1=pend.su;
s2=pend.si;
s3=pend.si;
s4=pend.sl;
s5=pend.sl;
% allows choice of 2 wires to set separation to zero
sn = 0;
dm=pend.dm;
dn=pend.dn;
d0=pend.d0;
d1=pend.d1;
d2=pend.d2;
d3=pend.d3;
d4=pend.d4;


%********************************************************************
mn = pend.mn;
m1 = pend.m1;
m2 = pend.m2;
m3 = pend.m3;
Inx = pend.Inx;
I1x = pend.I1x;
I2x = pend.I2x;
I3x = pend.I3x;
Iny = pend.Iny;
I1y = pend.I1y;
I2y = pend.I2y;
I3y = pend.I3y;
Inz = pend.Inz;
I1z = pend.I1z;
I2z = pend.I2z;
I3z = pend.I3z;

mn3  = mn+m1+m2+m3;
m13	= m1+m2+m3;
m23	= m2+m3;

nn0 = pend.nn0;
nn1 = pend.nn1;
n0  = pend.n0;
n1  = pend.n1;
n2  = pend.n2;
n3  = pend.n3;
n4  = pend.n4;
n5  = pend.n5;

%***********************************************************************************
% cosine and sine of the angle the wire makes with the vertical (z)

sin=(nn1-nn0)/ln;			%sin(omegan)

si1=(n1-n0)/l1;			%sin(omega1)
si2=(n3-n2)/l2;			%sin(omega2)
si3=(n5-n4)/l3;			%sin(omega3)	

cn=(ln^2-(nn1-nn0)^2)^0.5/ln;	%cos(omegan)

c1=(l1^2-(n1-n0)^2)^0.5/l1;	%cos(omega1)
c2=(l2^2-(n3-n2)^2)^0.5/l2;	%cos(omega2)
c3=(l3^2-(n5-n4)^2)^0.5/l3;	%cos(omega3)

%********************************************************
bd = pend.bd;
%********************************************************************
%longitudinal and pitch equations of motion 
k1 = k1p;
k2 = k2p;

k11	= -mn3*g*dm/Iny-2*kn*sn^2*cn^2/Iny-m13*g*dn/Iny-2*k1*s1^2*c1^2/Iny-m13*g*dn^2/Iny/l1/c1 ...
   -mn3*g*dm^2/Iny/ln/cn-mn3*g*sn^2*sin^2/Iny/ln/cn-m13*g*s1^2*si1^2/Iny/l1/c1;
k12	= -m13*g*dn/Iny/l1/c1+mn3*g*dm/Iny/ln/cn;
k1p	= -m13*g*dn*d1/Iny/l1/c1+2*k1*s1^2*c1^2/Iny+m13*g*s1^2*si1^2/l1/c1/Iny;
k1q	= +m13*g*dn/Iny/l1/c1;

k21	= +mn3*g*dm/mn/ln/cn-m13*g*dn/mn/l1/c1;
k22	= -mn3*g/mn/ln/cn-m13*g/mn/l1/c1;
k2p	= -m13*g*d0/mn/l1/c1;
k2q	= +m13*g/mn/l1/c1;

kp1	= +2*k1*s1^2*c1^2/I1y-m13*g*d1*dn/I1y/l1/c1+m13*g*s1^2*si1^2/I1y/l1/c1;
kp2	= -m13*g*d1/I1y/l1/c1 ;

kpp	= -m13*g*d1/I1y-2*k1*s1^2*c1^2/I1y-m23*g*d2/I1y-2*k2*s2^2*c2^2/I1y-m13*g*d1^2/I1y/l1/c1 ...
   -m23*g*d2^2/I1y/l2/c2-m13*g*s1^2*si1^2/l1/I1y/c1-m23*g*s2^2*si2^2/l2/I1y/c2;
kpq	= +m1*g*d1/I1y/l1/c1-m23*g*d2/I1y/l2/c2;
kp3	= -m23*g*d2*d2/I1y/l2/c2+2*k2*s2^2*c2^2/I1y+m23*g*s2^2*si2^2/l2/I1y/c2;
kp4	= +m23*g*d2/I1y/l2/c2;

kq1	= +m13*g*dn/m1/l1/c1;
kq2	= +m13*g/m1/l1/c1;
kqp	= +m13*g*d1/m1/l1/c1-d2*m23*g/m1/l2/c2;
kqq	= -m13*g/m1/l1/c1-m23*g/m1/l2/c2;
kq3	= -m23*g*d2/m1/l2/c2;
kq4	= +m23*g/m1/l2/c2;


k3p	= +2*k2*s2^2*c2^2/I2y-m23*g*d2*d1/I2y/l2/c2+m23*g*s2^2*si2^2/I2y/l2/c2;
k3q	= -m23*g*d2/I2y/l2/c2 ;
k33	= -m23*g*d2/I2y-2*k2*s2^2*c2^2/I2y-m3*g*d3/I2y-2*k3*s4^2*c3^2/I2y-m23*g*d2^2/I2y/l2/c2 ...
   -m3*g*d3^2/I2y/l3/c3-m23*g*s2^2*si2^2/l2/I2y/c2-m3*g*s4^2*si3^2/l3/I2y/c3;
k34	= +m23*g*d2/I2y/l2/c2-m3*g*d3/I2y/l3/c3;
k35	= -m3*g*d3*d4/I2y/l3/c3+2*k3*s4^2*c3^2/I2y+m3*g*s4^2*si3^2/l3/I2y/c3;
k36	= +m3*g*d3/I2y/l3/c3;

k4p	= +m23*g*d1/m2/l2/c2;
k4q	= +m23*g/m2/l2/c2;
k43	= +m23*g*d2/m2/l2/c2-d3*m3*g/m2/l3/c3;
k44	= -m23*g/m2/l2/c2-m3*g/m2/l3/c3;
k45	= -m3*g*d4/m2/l3/c3;
k46	= +m3*g/m2/l3/c3;

k53	= +2*k3*s4^2*c3^2/I3y-m3*g*d4*d3/l3/I3y/c3+m3*g*s4^2*si3^2/I3y/l3/c3;
k54	= -m3*g*d4/I3y/l3/c3;
k55	= -m3*g*d4/I3y-2*k3*s4^2*c3^2/I3y-m3*g*d4^2/I3y/l3/c3-m3*g*s4^2*si3^2/I3y/l3/c3;
k56	= +m3*g*d4/I3y/l3/c3;

k63	= +g*d3/l3/c3;
k64	= +g/l3/c3;
k65	= +g*d4/l3/c3;
k66	= -g/l3/c3;

%********************************************************

%state space matrices pitch and longitudinal
% masses in descending order (top = 1, intermediate = 2, mirror = 3)
% angle/displacement angle/displacement angle/displacement 
% unphysical damping used to make open loop phase plots readable
% set b = 0 for closed loop plots

A=[0	0	0	0	0	0 0 0		1	0	0	0	0	0 0 0
   0	0	0	0	0	0 0 0 	0	1	0	0	0	0 0 0		
   0	0	0	0	0	0 0 0	 	0	0	1	0	0	0 0 0
   0	0	0	0	0	0 0 0		0	0	0	1	0	0 0 0
   0	0	0	0	0	0 0 0 	0	0	0	0	1	0 0 0
   0	0	0	0	0	0 0 0 	0	0	0	0	0	1 0 0
   0	0	0	0	0	0 0 0 	0	0	0	0	0  0 1 0
   0	0	0	0	0	0 0 0 	0	0	0	0	0  0 0 1
   k11	 k12	k1p	k1q 0 0 	0  0	       -bd	0	0	0	0	0 0 0 
   k21	 k22	k2p	k2q 0 0 	0 	 0	        0	-bd	0	0	0	0 0 0
   kp1	 kp2	kpp	kpq	kp3	kp4 0 0 	  0	0	-bd	0	0	0 0 0
   kq1	 kq2	kqp	kqq	kq3	kq4 0 0    0	0	0	-bd	0	0	0 0
   0   0   k3p  k3q  k33  k34 k35 k36  		0	0 0 0 -bd 0 0 0 
   0   0   k4p  k4q  k43  k44 k45 k46  		0 0 0 0 0 -bd 0 0 
   0  0   0   0  	k53	k54	k55	k56		0 0 0	0	0	0	-bd	0
   0  0   0 	 0	  k63	k64	k65	k66		0 0 0	0	0	0	0	-bd];

B=[0 0 0 0 0 0 0 0 -mn3*g*dm/Iny/ln/cn +mn3*g/mn/ln/cn   0	0	0	0 0 0			%l ground
   0 0 0 0 0 0 0 0	       0	1/mn	  0	0	                     0	0 0 0		%l n
   0 0 0 0 0 0 0 0	       0	0	    0	1/m1	                  0	0 0 0			%l 1
   0 0 0 0 0 0 0 0	       0	0	    0	0	                     0	1/m2 0 0		%l 2
   0 0 0 0 0 0 0 0	       0	0	    0	0	                     0	0 0 1/m3    %l 3
   0 0 0 0 0 0 0 0     1/Iny  0	  0	0	                        0	0 0 0    %p n
   0 0 0 0 0 0 0 0	       0	0	    1/I1y	0	               0	0 0 0			%p 1
   0 0 0 0 0 0 0 0	       0	0	    0	0	                	   1/I2y  0 0 0   %p 2
   0 0 0 0 0 0 0 0	       0	0	    0	0	                     0	0 1/I3y 0	%p 3
]';

C=[0	1	0	0	 0	  0	0	0	 0	 0	 0	 0   0 0 0 0     %l n
   0 0 0 1   0	  0	0	0	 0	 0	 0	 0	  0	0	0	0    %l 
   0 0 0 0   0	  1	0	0	 0	 0	 0	 0	  0	0	0	0
   0 0 0 0   0	  0	0	1	 0	 0	 0	 0	  0	0	0	0
   1 0 0 0   0	  0	0	0	 0	 0	 0	 0	  0	0	0	0
   0	0	1	0	 0	  0	0	0	 0	 0	 0	 0   0 0 0 0
   0	0	0	0	 1	  0	0	0	 0	 0	 0	 0   0 0 0 0
   0	0	0	0	 0	  0	1	0	 0	 0	 0	 0   0 0 0 0
   0  0  0  0   0   0   0  0   0  1  0  0  0  0  0  0   %long vel
   0  0  0  0   0   0   0  0   1  0  0  0  0  0  0  0   %pitch vel

  ];
 
 D=[0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0  
    0   0  0  0  0  0  0  0 0   
 ];


lpe = ss(A,B,C,D);


%********************************************************************
% yaw
k1 = k1v;
k2 = k2v;

NN	=mn3*g/ln/cn*(sn^2*cn^2+nn0*nn1)+2*kn*sn^2*(nn1-nn0)^2/ln^2;
AA	=m13*g/l1/c1*(s0^2*c1^2+n0*n1)+2*k1*s0^2*(n1-n0)^2/l1^2;
BB	=m23*g/l2/c2*(s2^2*c2^2+n2*n3)+2*k2*s2^2*(n3-n2)^2/l2^2;
CC	=m3*g/l3/c3*(s4^2*c3^2+n4*n5)+2*k3*s4^2*(n5-n4)^2/l3^2;

i11	=-NN/Inz-AA/Inz; %&
i1m	=  AA/Inz;
im1  = AA/I1z;
imm  =-AA/I1z - BB/I1z;
im2  = BB/I1z;
i2m	= BB/I2z;
i22	=-BB/I2z-CC/I2z;
i23	= CC/I2z;
i32	= CC/I3z;
i33	=-CC/I3z;

% topmass/intermediatemass/mirror coordinates 1,2,3

ar=[	0	0	0 0	1	0	0 0
   0	0	0 0	0	1	0 0
   0	0	0 0	0	0	1 0
   0 0  0 0 0 0 0 1
   i11	i1m	0	0      -bd 	0	 0 0
   im1  imm im2 0    0    -bd   0 0
   0 i2m	i22	i23    0 	0	-bd	 0
   0	 0  i32	 i33	    0  0	 0	-bd];
br=[ 0	0	0 0	NN/Inz	0	0 0       %guess????
   0	0	0 0	1/Inz	0	0 0
   0	0	0 0	0	1/I1z	0 0
   0	0	0 0	0	0 1/I2z	  0	
   0	0	0	0  0 0 0	1/I3z]';

cr=[	1	0	0	0	0	0 0 0	
   	0	1	0	0	0	0 0 0	
   	0	0	1	0	0	0 0 0
      0	0	0 	1	0	0	0 0
      0  0  0  0  1  0  0 0];
dr=[ 0 0 0 0 0 
     0 0 0 0 0 
     0 0 0 0 0 
     0 0 0 0 0
     0 0 0 0 0  ];


ye = ss(ar,br,cr,dr);

%********************************************************************  
%vertical

   hn=2*kn*cn^2+mn3*g*sin^2/ln/cn;
   h1=2*k1*c1^2+m13*g*si1^2/l1/c1;
   h2=2*k2*c2^2+m23*g*si2^2/l2/c2;
   h3=2*k3*c3^2+m3*g*si3^2/l3/c3;
   
   h11 = - hn/mn - h1 /mn;
   h1m = h1/  mn  ;
   hmm = - h1/m1 - h2/ m1;
   hm1 = h1 / m1;
   hm2 = h2 / m1;
   h2m = h2 / m2;
   h22 = - h2 / m2 - h3 / m2;
   h23 = h3 / m2 ;
   h32 = h3 / m3;
   h33 = - h3 / m3;
   
   av= [ 0 0 0 0  1 0 0 0 	
         0 0 0 0  0 1 0 0 	
         0 0 0 0  0 0 1 0
         0 0 0 0  0 0 0 1
      h11	h1m	0  0	      -bd	0	0 0
      hm1 hmm hm2 0      0 -bd 0 0 
      0 h2m 	h22	h23   0 0	-bd	0		
      0 0	   h32	h33     0 0	0	-bd];
   
   bv= [ 0	0	0 0   	hn /mn  0 0	0
      	0	0	0 0	   1 /mn   0 0 0
      	0	0	0 0	     0 1 /m1 0 0]';
   
   cv= [1	0	0 0 0	0	0	0	
        0	1	0 0 0	0	0	0	
        0	0	1 0 0	0	0	0	
        0	0	0 1 0	0	0	0
        0	0	0 0 1	0	0	0];
   
   dv= [0 0 0 
        0 0 0 
        0 0 0  
        0 0 0 
        0 0 0];
     
   ve = ss(av,bv,cv,dv);

% SIDEWAYS AND ROLL 

d3 = pend.d3tr;%ribbons have different `d's 
d4 = pend.d4tr;%ribbons have different `d's 
jnn	= -mn3*g*dm/Inx+mn3*g*nn1*sin/Inx/cn-2*kn*nn1^2/Inx-2*kn*dm*sin*nn1/Inx/cn-m13*g*dn/Inx-m13*g*n0*si1/Inx/c1-2*k1*n0^2/Inx+2*k1*dn*si1*n0/Inx/c1 +mn3*g*dm/Inx*(nn1*sin/ln-dm*cn/ln)-mn3*g*nn1*sin/Inx/cn*(nn1*sin/ln-dm*cn/ln)+2*kn*ln*sin*nn1/Inx*(nn1*sin/ln-dm*cn/ln)+2*kn*ln*dm*sin^2/Inx/cn*(nn1*sin/ln-dm*cn/ln) +m13*g*dn/Inx*(-n0*si1/l1-dn*c1/l1)+m13*g*n0*si1/Inx/c1*(-n0*si1/l1-dn*c1/l1)-2*k1*l1*si1*n0/Inx*(-n0*si1/l1-dn*c1/l1)+2*k1*l1*dn*si1^2/Inx/c1*(-n0*si1/l1-dn*c1/l1);	
jnm	= -m13*g*dn/Inx*c1/l1-m13*g*n0*si1/Inx/l1+2*k1*si1*n0/Inx*c1-2*k1*dn*si1^2/Inx +mn3*g*dm/Inx*cn/ln-mn3*g*nn1*sin/Inx/ln+2*kn*sin*nn1/Inx*cn+2*kn*dm*sin^2/Inx;
jn1	= +m13*g*dn/Inx*(n1*si1/l1-d0*c1/l1)+m13*g*n0*si1/Inx/c1*(n1*si1/l1-d0*c1/l1)-2*k1*l1*si1*n0/Inx*(n1*si1/l1-d0*c1/l1) +2*k1*l1*si1^2*dn/Inx*(n1*si1/l1-d0*c1/l1) +2*k1*n0*n1/Inx-2*k1*dn*si1*n1/Inx/c1; 
jn2	= +m13*g*dn*c1/l1/Inx+m13*g*n0*si1/Inx/l1-2*k1*si1*n0/Inx*c1+2*k1*dn*si1^2/Inx;
jn3	= 0;
jn4	= 0;
jn5	= 0;
jn6	= 0;

jmn	= -mn3*g/mn*(nn1*sin/ln-dm*cn/ln)+2*kn*nn1*sin/mn/cn-2*kn*ln*sin^2/mn/cn*(nn1*sin/ln-dm*cn/ln)+m13*g/mn*(-n0*si1/l1-dn*c1/l1)+2*k1*l1*si1^2/mn/c1*(-n0*si1/l1-dn*c1/l1)   +2*k1*n0*si1/mn/c1;
jmm	= -mn3*g*cn/mn/ln-2*kn*ln*sin^2/mn/ln-m13*g*c1/mn/l1-2*k1*l1*si1^2/mn/l1;
jm1	= -2*k1*n1*si1/mn/c1+m13*g/mn*(n1*si1/l1-d0*c1/l1)+2*k1*l1*si1^2/mn/c1*(n1*si1/l1-d0*c1/l1);
jm2	= +m13*g*c1/mn/l1+2*k1*l1*si1^2/mn/l1;
jm3	= 0;
jm4	= 0;
jm5	= 0;
jm6	= 0;

j1n	= +m13*g*d0/I1x*(-n0*si1/l1-dn*c1/l1)-m13*g*n1*si1/I1x/c1*(-n0*si1/l1-dn*c1/l1)+2*k1*l1*si1*n1/I1x*(-n0*si1/l1-dn*c1/l1)+2*k1*l1*d0*si1^2/I1x/c1*(-n0*si1/l1-dn*c1/l1)+2*k1*n1*n0/I1x+2*k1*d0*si1*n0/I1x/c1;
j1m	= -m13*g*d0/I1x*(c1/l1)+m13*g*n1*si1/I1x/c1*c1/l1-2*k1*l1*si1*n1/I1x*c1/l1-2*k1*l1*d0*si1^2/I1x/c1*c1/l1;
j11	= -m13*g*d0/I1x+m13*g*n1*si1/I1x/c1-2*k1*n1^2/I1x-2*k1*n1*d0*si1/I1x/c1-m23*g*d1/I1x-m23*g*n2*si2/I1x/c2-2*k2*n2^2/I1x+2*k2*n2*d1*si2/I1x/c2+m13*g*d0/I1x*(n1*si1/l1-d0*c1/l1)-m13*g*n1*si1/I1x/c1*(n1*si1/l1-d0*c1/l1)+2*k1*l1*si1*n1/I1x*(n1*si1/l1-d0*c1/l1)+2*k1*l1*d0*si1^2/I1x/c1*(n1*si1/l1-d0*c1/l1)+m23*g*d1/I1x*(-n2*si2/l2-d1*c2/l2)+m23*g*n2*si2/I1x/c2*(-n2*si2/l2-d1*c2/l2)-2*k2*l2*si2*n2/I1x*(-n2*si2/l2-d1*c2/l2)+2*k2*l2*d1*si2^2/I1x/c2*(-n2*si2/l2-d1*c2/l2);
j12	= -m23*g*d1*c2/I1x/l2-m23*g*n2*si2/I1x/l2+2*k2*si2*n2*c2/I1x-2*k2*d1*si2^2/I1x+m13*g*d0*c1/I1x/l1-m13*g*n1*si1/I1x/l1+2*k1*si1*n1*c1/I1x+2*k1*d0*si1^2/I1x;
j13	= m23*g*d1/I1x*(n3*si2/l2-d2*c2/l2)+m23*g*n2*si2/I1x/c2*(n3*si2/l2-d2*c2/l2)-2*k2*l2*si2*n2/I1x*(n3*si2/l2-d2*c2/l2)+2*k2*l2*d1*si2^2/I1x/c2*(n3*si2/l2-d2*c2/l2)+2*k2*n2*n3/I1x-2*k2*d1*si2*n3/I1x/c2;
j14	= +m23*g*d1*c2/I1x/l2+m23*g*n2*si2/I1x/l2-2*k2*si2*n2*c2/I1x+2*k2*d1*si2^2/I1x;
j15	= 0;
j16	= 0;

j2n	= -m13*g/m1*(n0*si1/l1-dn*c1/l1)-2*k1*l1*si1^2/m1/c1*(n0*si1/l1-dn*c1/l1)-2*k1*n0*si1/m1/c1;
j2m	= +m13*g*c1/l1/m1+2*k1*si1^2/m1;
j21	= -m13*g/m1*(n1*si1/l1-d0*c1/l1)-2*k1*l1*si1^2/m1/c1*(n1*si1/l1-d0*c1/l1)+2*k1*n1*si1/m1/c1+m23*g/m1*(-n2*si2/l2-d1*c2/l2)+2*k2*l2*si2^2/m1/c2*(-n2*si2/l2-d1*c2/l2)+2*k2*n2*si2/m1/c2;
j22	= -m13*g*c1/m1/l1-m23*g*c2/m1/l2-2*k1*si1^2/m1-2*k2*si2^2/m1;
j23	= -2*k2*n3*si2/m1/c2+m23*g/m1*(n3*si2/l2-d2*c2/l2)+2*k2*l2*si2^2/m1/c2*(n3*si2/l2-d2*c2/l2);
j24	= +m23*g*c2/m1/l2+2*k2*si2^2/m1;
j25	= 0;
j26	= 0;		

j3n	= 0;
j3m	= 0;
j31	=+m23*g*d2/I2x*(-n2*si2/l2-d1*c2/l2)-m23*g*n3*si2/I2x/c2*(-n2*si2/l2-d1*c2/l2)+2*k2*l2*si2*n3/I2x*(-n2*si2/l2-d1*c2/l2)+2*k2*l2*d2*si2^2/I2x/c2*(-n2*si2/l2-d1*c2/l2)+2*k2*n2*n3/I2x+2*k2*d2*n2*si2/I2x/c2;
j32	= -(+m23*g*d2*c2/I2x/l2-m23*g*n3*si2/I2x/l2+2*k2*si2*n3*c2/I2x+2*k2*d2*si2^2/I2x);
j33	= +m23*g*d2/I2x*(n3*si2/l2-d2*c2/l2)-m23*g*n3*si2/I2x/c2*(n3*si2/l2-d2*c2/l2)+2*k2*l2*si2*n3/I2x*(n3*si2/l2-d2*c2/l2)+2*k2*l2*d2*si2^2/I2x/c2*(n3*si2/l2-d2*c2/l2)-2*k2*n3*n3/I2x-2*k2*d2*n3*si2/I2x/c2-m23*g*d2/I2x+m23*g*n3*si2/I2x/c2+m3*g*d3/I2x*(-n4*si3/l3-d3*c3/l3)+m3*g*n4*si3/I2x/c3*(-n4*si3/l3-d3*c3/l3)-2*k3*l3*si3*n4/I2x*(-n4*si3/l3-d3*c3/l3)+2*k3*l3*d3*si3^2/I3x/c3*(-n4*si3/l3-d3*c3/l3)-2*k3*n4*n4/I2x+2*k3*d3*n4*si3/I2x/c3-m3*g*d3/I2x-m3*g*n4*si3/I2x/c3;
j34	=-(+m3*g*d3*c3/I2x/l3+m3*g*n4*si3/I2x/l3-2*k3*si3*n4*c3/I2x+2*k3*d3*si3^2/I2x)+m23*g*d2*c2/I2x/l2-m23*g*n3*si2/I2x/l2+2*k2*si2*n3*c2/I2x+2*k2*d2*si2^2/I2x;

j35	=+m3*g*d3/I2x*(n5*si3/l3-d4*c3/l3)+m3*g*n4*si3/I2x/c3*(n5*si3/l3-d4*c3/l3)-2*k3*l3*si3*n4/I2x*(n5*si3/l3-d4*c3/l3)+2*k3*l3*d3*si3^2/I2x/c3*(n5*si3/l3-d4*c3/l3)+2*k3*n4*n5/I2x-2*k3*d3*n5*si3/I2x/c3;

j36	=+m3*g*d3*c3/I2x/l3+m3*g*n4*si3/I2x/l3-2*k3*si3*n4*c3/I2x+2*k3*d3*si3^2/I2x;

j4n	= 0;
j4m	= 0;
j41	= +m23*g*si2*n2/m2/l2+m23*g*c2*d1/m2/l2+2*k2*si2^3*n2/m2/c2+2*k2*si2^2*d1/m2-2*k2*n2*si2/m2/c2;
j42	= +m23*g*c2/m2/l2+2*k2*si2^2/m2;
j43	= -m23*g*n3*si2/m2/l2+m23*g*d2*c2/m2/l2-2*k2*l2*si2^2/m2/c2*(n3*si2/l2-d2*c2/l2)+2*k2*n3*si2/m2/c2+2*k3*l3*si3^2/m2/c3*(-n4*si3/l3-d3*c3/l3)+m3*g/m2*(-n4*si3/l3-d3*c3/l3)+2*k3*n4*si3/m2/c3;
j44	= -m23*g*c2/m2/l2-m3*g*c3/m2/l3-2*k2*si2^2/m2-2*k3*si3^2/m2;
j45	= -m3*g*d4*c3/m2/l3+m3*g*n5*si3/l3/m2-2*k3*n5*si3/m2/c3+2*k3*l3*si3^2/m2/c3*(n5*si3/l3-d4*c3/l3);
j46	= +m3*g*c3/m2/l3+2*k3*si3^2/m2;

j5n	= 0;
j5m	= 0;
j51	= 0;
j52	= 0;
j53	=+m3*g*d4/I3x*(-n4*si3/l3-d3*c3/l3)-m3*g*n5*si3/I3x/c3*(-n4*si3/l3-d3*c3/l3)+2*k3*l3*si3*n5/I3x*(-n4*si3/l3-d3*c3/l3)+2*k3*l3*d4*si3^2/I3x/c3*(-n4*si3/l3-d3*c3/l3)+2*k3*n5*n4/I3x+2*k3*d4*n4*si3/I3x/c3;
j54	= -(+m3*g*d4*c3/I3x/l3-m3*g*n5*si3/I3x/l3+2*k3*si3*n5*c3/I3x+2*k3*d4*si3^2/I3x);
j55	=-m3*g*d4/I3x+m3*g*n5*si3/I3x/c3+m3*g*d4/I3x*(n5*si3/l3-d4*c3/l3)-m3*g*n5*si3/I3x/c3*(n5*si3/l3-d4*c3/l3)+2*k3*l3*si3*n5/I3x*(n5*si3/l3-d4*c3/l3)+2*k3*l3*d4*si3^2/I3x/c3*(n5*si3/l3-d4*c3/l3)-2*k3*n5^2/I3x-2*k3*d4*n5*si3/I3x/c3;
j56	= +m3*g*d4*c3/I3x/l3-m3*g*n5*si3/I3x/l3+2*k3*si3*n5*c3/I3x+2*k3*d4*si3^2/I3x;

j6n	= 0;
j6m	= 0;
j61	= 0;
j62	= 0;
j63	= -g*(-n4*si3/l3-d3*c3/l3)-2*k3*si3^2/m3/c3*(-n4*si3-d3*c3)-2*k3*n4*si3/m3/c3;
j64	= +g*c3/l3+2*k3*si3^2/m3;
j65	= -g*(n5*si3/l3-d4*c3/l3)-2*k3*si3^2/m3/c3*(n5*si3-d4*c3)+2*k3*n5*si3/m3/c3;
j66	= -g*c3/l3-2*k3*si3^2/m3;


%state space matrices


%	qn    xn    q1   x1   q2   x2   q3   x3   Qn    vn   Q1   v1   Q2   v2   Q3   v3		

AA=[	0     0     0    0    0    0    0    0    1     0     0    0    0    0    0    0
	0     0     0	 0    0    0	0    0    0     1     0    0    0    0    0    0			
   	0     0     0    0    0    0	0    0	  0     0     1    0	0    0    0    0
   	0     0     0    0    0    0	0    0	  0     0     0    1	0    0    0    0	
	0     0     0    0    0    0	0    0	  0     0     0    0	1    0    0    0
	0     0     0    0    0    0	0    0	  0     0     0    0	0    1    0    0
	0     0     0    0    0    0	0    0	  0     0     0    0	0    0    1    0
	0     0     0    0    0    0	0    0	  0     0     0    0	0    0    0    1
	jnn  jnm   jn1  jn2  jn3  jn4  jn5  jn6  -bd    0     0    0    0    0    0    0
	jmn  jmm   jm1  jm2  jm3  jm4  jm5  jm6   0    -bd    0    0    0    0    0    0
	j1n  j1m   j11  j12  j13  j14  j15  j16	  0     0    -bd   0    0    0    0    0
   j2n  j2m   j21  j22  j23  j24  j25  j26	  0     0     0   -bd   0    0    0    0
   j3n  j3m   j31  j32  j33  j34  j35  j36	  0     0     0    0   -bd   0    0    0
   j4n  j4m   j41  j42  j43  j44  j45  j46	  0	0     0    0    0   -bd   0    0
	j5n  j5m   j51  j52  j53  j54  j55  j56	  0	0     0    0    0    0   -bd   0
   j6n  j6m   j61  j62  j63  j64  j65  j66	  0	0     0    0    0    0    0   -bd];
   
   
Qnx0 = -mn3*g*dm/Inx*cn/ln-mn3*g*nn1*sin/Inx/cn*cn/ln-2*kn*ln*sin*nn1/Inx*cn/ln-2*kn*ln*dm*sin^2/Inx/cn*cn/ln;
xnx0 = +mn3*g*cn/ln/mn+2*kn*ln*sin^2/ln/mn;

BB=[0 0 0 0 0 0 0 0   Qnx0  xnx0  0  	0		0	0	0 0 
    0 0 0 0 0 0 0 0   0     1/mn  0  	0  	0	0 	0 0
    0 0 0 0 0 0 0 0   0       0   0    1/m1  0	0 	0 0
    0 0 0 0 0 0 0 0   jnn    jmm   0  	0		0	0 	0 0
    0 0 0 0 0 0 0 0   1/Inx   0   0  	0		0	0 	0 0
    0 0 0 0 0 0 0 0     0     0   1/I1x 0  	0	0 	0 0
]';

CC=[0	1	0	0	0	0	0	0	0	0	0	0	0	0	0	0 
    0	0	0	1	0	0	0	0	0	0	0	0	0	0	0	0
    0	0 	0	0	0	1	0	0	0	0	0	0	0	0	0	0
    0	0 	0	0	0	0	0	1	0	0	0	0	0	0	0	0
    1	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
    0	0	1	0	0	0	0	0	0	0	0	0	0	0	0	0
    0	0	0	0	1	0	0	0	0	0	0	0	0	0	0	0
    0	0	0	0	0	0	1	0	0	0	0	0	0	0	0	0  
    0	0	0	0	0	0	0	0	0	1	0	0	0	0	0	0
    0	0	0	0	0	0	0	0	1	0	0	0	0	0	0	0];
 
 DD=[0   0  0  0  0  0
     0   0  0  0  0  0
     0   0  0  0  0  0
     0   0  0  0  0  0   
     0   0  0  0  0  0     
     0   0  0  0  0  0     
     0   0  0  0  0  0     
     0   0  0  0  0  0     
  	  0   0  0  0  0  0     
     0   0  0  0  0  0     
    ];
 


trer = ss(AA,BB,CC,DD);   
